create type "id_int16";

create function "id_int16_in"(cstring) returns "id_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_out"("id_int16") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_send"("id_int16") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_recv"(internal) returns "id_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int16"
(
    input = "id_int16_in",
    output = "id_int16_out",
    internallength = 4,
    alignment = int2,
    send = "id_int16_send",
    receive = "id_int16_recv"
);

create function "id_int16_eq"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_neq"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_leq"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_lt"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_geq"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_gt"("id_int16", "id_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_cmp"("id_int16", "id_int16") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_nextval"("int2", "regclass") returns "id_int16" as
'MODULE_PATHNAME' language c;

create function "id_int16_make"("int2",
                                      "int2") returns "id_int16" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int16_eq",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int16_neq",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int16_lt",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int16_gt",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int16_leq",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int16_geq",
    leftarg = "id_int16",
    rightarg = "id_int16",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int16_ops"
    default for type "id_int16"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int16_cmp"("id_int16", "id_int16");

create type "id_int16_int32";

create function "id_int16_int32_in"(cstring) returns "id_int16_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int32_out"("id_int16_int32") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int32_send"("id_int16_int32") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int32_recv"(internal) returns "id_int16_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int16_int32"
(
    input = "id_int16_int32_in",
    output = "id_int16_int32_out",
    internallength = 6,
    alignment = int4,
    send = "id_int16_int32_send",
    receive = "id_int16_int32_recv"
);

create function "id_int16_int32_eq"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_neq"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_leq"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_lt"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_geq"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_gt"("id_int16_int32", "id_int16_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int32_cmp"("id_int16_int32", "id_int16_int32") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int32_nextval"("int2", "regclass") returns "id_int16_int32" as
'MODULE_PATHNAME' language c;

create function "id_int16_int32_make"("int2",
                                      "int4") returns "id_int16_int32" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int16_int32_eq",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int16_int32_neq",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int16_int32_lt",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int16_int32_gt",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int16_int32_leq",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int16_int32_geq",
    leftarg = "id_int16_int32",
    rightarg = "id_int16_int32",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int16_int32_ops"
    default for type "id_int16_int32"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int16_int32_cmp"("id_int16_int32", "id_int16_int32");

create type "id_int16_int64";

create function "id_int16_int64_in"(cstring) returns "id_int16_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int64_out"("id_int16_int64") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int64_send"("id_int16_int64") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int64_recv"(internal) returns "id_int16_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int16_int64"
(
    input = "id_int16_int64_in",
    output = "id_int16_int64_out",
    internallength = 10,
    alignment = double,
    send = "id_int16_int64_send",
    receive = "id_int16_int64_recv"
);

create function "id_int16_int64_eq"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_neq"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_leq"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_lt"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_geq"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_gt"("id_int16_int64", "id_int16_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int16_int64_cmp"("id_int16_int64", "id_int16_int64") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int16_int64_nextval"("int2", "regclass") returns "id_int16_int64" as
'MODULE_PATHNAME' language c;

create function "id_int16_int64_make"("int2",
                                      "int8") returns "id_int16_int64" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int16_int64_eq",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int16_int64_neq",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int16_int64_lt",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int16_int64_gt",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int16_int64_leq",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int16_int64_geq",
    leftarg = "id_int16_int64",
    rightarg = "id_int16_int64",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int16_int64_ops"
    default for type "id_int16_int64"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int16_int64_cmp"("id_int16_int64", "id_int16_int64");

create type "id_int32_int16";

create function "id_int32_int16_in"(cstring) returns "id_int32_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int16_out"("id_int32_int16") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int16_send"("id_int32_int16") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int16_recv"(internal) returns "id_int32_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int32_int16"
(
    input = "id_int32_int16_in",
    output = "id_int32_int16_out",
    internallength = 6,
    alignment = int4,
    send = "id_int32_int16_send",
    receive = "id_int32_int16_recv"
);

create function "id_int32_int16_eq"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_neq"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_leq"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_lt"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_geq"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_gt"("id_int32_int16", "id_int32_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int16_cmp"("id_int32_int16", "id_int32_int16") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int16_nextval"("int4", "regclass") returns "id_int32_int16" as
'MODULE_PATHNAME' language c;

create function "id_int32_int16_make"("int4",
                                      "int2") returns "id_int32_int16" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int32_int16_eq",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int32_int16_neq",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int32_int16_lt",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int32_int16_gt",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int32_int16_leq",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int32_int16_geq",
    leftarg = "id_int32_int16",
    rightarg = "id_int32_int16",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int32_int16_ops"
    default for type "id_int32_int16"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int32_int16_cmp"("id_int32_int16", "id_int32_int16");

create type "id_int32";

create function "id_int32_in"(cstring) returns "id_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_out"("id_int32") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_send"("id_int32") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_recv"(internal) returns "id_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int32"
(
    input = "id_int32_in",
    output = "id_int32_out",
    internallength = 8,
    alignment = int4,
    send = "id_int32_send",
    receive = "id_int32_recv"
);

create function "id_int32_eq"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_neq"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_leq"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_lt"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_geq"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_gt"("id_int32", "id_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_cmp"("id_int32", "id_int32") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_nextval"("int4", "regclass") returns "id_int32" as
'MODULE_PATHNAME' language c;

create function "id_int32_make"("int4",
                                      "int4") returns "id_int32" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int32_eq",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int32_neq",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int32_lt",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int32_gt",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int32_leq",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int32_geq",
    leftarg = "id_int32",
    rightarg = "id_int32",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int32_ops"
    default for type "id_int32"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int32_cmp"("id_int32", "id_int32");

create type "id_int32_int64";

create function "id_int32_int64_in"(cstring) returns "id_int32_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int64_out"("id_int32_int64") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int64_send"("id_int32_int64") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int64_recv"(internal) returns "id_int32_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int32_int64"
(
    input = "id_int32_int64_in",
    output = "id_int32_int64_out",
    internallength = 12,
    alignment = double,
    send = "id_int32_int64_send",
    receive = "id_int32_int64_recv"
);

create function "id_int32_int64_eq"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_neq"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_leq"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_lt"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_geq"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_gt"("id_int32_int64", "id_int32_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int32_int64_cmp"("id_int32_int64", "id_int32_int64") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int32_int64_nextval"("int4", "regclass") returns "id_int32_int64" as
'MODULE_PATHNAME' language c;

create function "id_int32_int64_make"("int4",
                                      "int8") returns "id_int32_int64" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int32_int64_eq",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int32_int64_neq",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int32_int64_lt",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int32_int64_gt",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int32_int64_leq",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int32_int64_geq",
    leftarg = "id_int32_int64",
    rightarg = "id_int32_int64",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int32_int64_ops"
    default for type "id_int32_int64"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int32_int64_cmp"("id_int32_int64", "id_int32_int64");

create type "id_int64_int16";

create function "id_int64_int16_in"(cstring) returns "id_int64_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int16_out"("id_int64_int16") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int16_send"("id_int64_int16") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int16_recv"(internal) returns "id_int64_int16"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int64_int16"
(
    input = "id_int64_int16_in",
    output = "id_int64_int16_out",
    internallength = 10,
    alignment = double,
    send = "id_int64_int16_send",
    receive = "id_int64_int16_recv"
);

create function "id_int64_int16_eq"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_neq"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_leq"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_lt"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_geq"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_gt"("id_int64_int16", "id_int64_int16") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int16_cmp"("id_int64_int16", "id_int64_int16") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int16_nextval"("int8", "regclass") returns "id_int64_int16" as
'MODULE_PATHNAME' language c;

create function "id_int64_int16_make"("int8",
                                      "int2") returns "id_int64_int16" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int64_int16_eq",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int64_int16_neq",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int64_int16_lt",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int64_int16_gt",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int64_int16_leq",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int64_int16_geq",
    leftarg = "id_int64_int16",
    rightarg = "id_int64_int16",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int64_int16_ops"
    default for type "id_int64_int16"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int64_int16_cmp"("id_int64_int16", "id_int64_int16");

create type "id_int64_int32";

create function "id_int64_int32_in"(cstring) returns "id_int64_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int32_out"("id_int64_int32") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int32_send"("id_int64_int32") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int32_recv"(internal) returns "id_int64_int32"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int64_int32"
(
    input = "id_int64_int32_in",
    output = "id_int64_int32_out",
    internallength = 12,
    alignment = double,
    send = "id_int64_int32_send",
    receive = "id_int64_int32_recv"
);

create function "id_int64_int32_eq"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_neq"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_leq"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_lt"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_geq"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_gt"("id_int64_int32", "id_int64_int32") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_int32_cmp"("id_int64_int32", "id_int64_int32") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_int32_nextval"("int8", "regclass") returns "id_int64_int32" as
'MODULE_PATHNAME' language c;

create function "id_int64_int32_make"("int8",
                                      "int4") returns "id_int64_int32" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int64_int32_eq",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int64_int32_neq",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int64_int32_lt",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int64_int32_gt",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int64_int32_leq",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int64_int32_geq",
    leftarg = "id_int64_int32",
    rightarg = "id_int64_int32",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int64_int32_ops"
    default for type "id_int64_int32"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int64_int32_cmp"("id_int64_int32", "id_int64_int32");

create type "id_int64";

create function "id_int64_in"(cstring) returns "id_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_out"("id_int64") returns cstring
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_send"("id_int64") returns bytea
as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_recv"(internal) returns "id_int64"
as
'MODULE_PATHNAME' language c immutable
                             strict;

create type "id_int64"
(
    input = "id_int64_in",
    output = "id_int64_out",
    internallength = 16,
    alignment = double,
    send = "id_int64_send",
    receive = "id_int64_recv"
);

create function "id_int64_eq"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_neq"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_leq"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_lt"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_geq"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_gt"("id_int64", "id_int64") returns boolean as
'MODULE_PATHNAME' language c immutable
                             strict;
create function "id_int64_cmp"("id_int64", "id_int64") returns int as
'MODULE_PATHNAME' language c immutable
                             strict;

create function "id_int64_nextval"("int8", "regclass") returns "id_int64" as
'MODULE_PATHNAME' language c;

create function "id_int64_make"("int8",
                                      "int8") returns "id_int64" as
'MODULE_PATHNAME' language c;

create operator = (
    procedure = "id_int64_eq",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = =,
    negator = <>,
    restrict = eqsel,
    join = eqjoinsel,
    merges,
    hashes
    );

create operator <> (
    procedure = "id_int64_neq",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = <>,
    negator = =,
    restrict = neqsel,
    join = neqjoinsel
    );

create operator < (
    procedure = "id_int64_lt",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = >,
    negator = >=,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator > (
    procedure = "id_int64_gt",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = <,
    negator = <=,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator <= (
    procedure = "id_int64_leq",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = >=,
    negator = >,
    restrict = scalarltsel,
    join = scalarltjoinsel
    );

create operator >= (
    procedure = "id_int64_geq",
    leftarg = "id_int64",
    rightarg = "id_int64",
    commutator = <=,
    negator = <,
    restrict = scalargtsel,
    join = scalargtjoinsel
    );

create operator class "id_int64_ops"
    default for type "id_int64"
    using btree
    as
    operator 1 <,
    operator 2 <=,
    operator 3 =,
    operator 4 >= ,
    operator 5 > ,
    function 1 "id_int64_cmp"("id_int64", "id_int64");


create function system_identifier() returns bigint
as
'MODULE_PATHNAME' language c immutable;;
